#!/usr/bin/perl
#
# usage: convertdbm.pl DB directory
# usage: convertdbm.pl directory DB
#
# Copyright 2001 by Anthony Howe.  All rights reserved.
#

use AnyDBM_File;

unless (@ARGV == 2) {
	print STDERR "usage: convertdbm.pl DBM directory\n";
	print STDERR "       convertdbm.pl directory DBM\n";
}

if (-d $ARGV[0]) {
	unless (opendir(DIR, "$ARGV[0]")) {
		die("Cannot open directory \"$ARGV[0]\": $!\n");	
	}
	
	unless (dbmopen(%db, $ARGV[1], 0600)) {
		die("Cannot open DBM file \"$ARGV[1]\": $!\n");
	}

	while (($k = readdir(DIR))) {
		next unless open(WEENIE, "$ARGV[0]/$k");
		next if $k eq "." || $k eq "..";		
		$v = <WEENIE>;
		close(WEENIE);
		$v =~ s/(?:\r?\n|\r)$//;
		$db{$k} = $v;		
	}
	
	closedir(DIR);	
} elsif (-d $ARGV[1]) {
	unless (dbmopen(%db, $ARGV[0], 0600)) {
		die("Cannot open DBM file \"$ARGV[0]\": $!\n");
	}

	while (($k, $v) = each %db) {
		next unless open(WEENIE, ">$ARGV[1]/$k");
		print WEENIE "$v\n";
		close(WEENIE);
	}
} else {
	die("Nothing happened.");
}

dbmclose(%db);
